public inbox for devel@edk2.groups.io
 help / color / mirror / Atom feed
From: "Michael D Kinney" <michael.d.kinney@intel.com>
To: devel@edk2.groups.io
Cc: Jordan Justen <jordan.l.justen@intel.com>,
	Ray Ni <ray.ni@intel.com>, Andrew Fish <afish@apple.com>
Subject: [Patch V4 06/10] EmulatorPkg: Fix XCODE5 lldb issues
Date: Thu, 15 Aug 2019 19:14:33 -0700	[thread overview]
Message-ID: <20190816021437.7516-7-michael.d.kinney@intel.com> (raw)
In-Reply-To: <20190816021437.7516-1-michael.d.kinney@intel.com>

Fix scripts to support lldb symbolic debugging when
using XCODE5 tool chain.

Cc: Jordan Justen <jordan.l.justen@intel.com>
Cc: Ray Ni <ray.ni@intel.com>
Cc: Michael D Kinney <michael.d.kinney@intel.com>
Signed-off-by: Andrew Fish <afish@apple.com>
---
 EmulatorPkg/Unix/lldbefi.py |  8 +++++---
 EmulatorPkg/build.sh        | 17 ++---------------
 2 files changed, 7 insertions(+), 18 deletions(-)

diff --git a/EmulatorPkg/Unix/lldbefi.py b/EmulatorPkg/Unix/lldbefi.py
index 218326b8cb..099192d8b5 100755
--- a/EmulatorPkg/Unix/lldbefi.py
+++ b/EmulatorPkg/Unix/lldbefi.py
@@ -346,6 +346,7 @@ def TypePrintFormating(debugger):
     debugger.HandleCommand("type summary add CHAR8 --python-function lldbefi.CHAR8_TypeSummary")
     debugger.HandleCommand('type summary add --regex "CHAR8 \[[0-9]+\]" --python-function lldbefi.CHAR8_TypeSummary')
 
+    debugger.HandleCommand('setting set frame-format "frame #${frame.index}: ${frame.pc}{ ${module.file.basename}{:${function.name}()${function.pc-offset}}}{ at ${line.file.fullpath}:${line.number}}\n"')
 
 gEmulatorBreakWorkaroundNeeded = True
 
@@ -381,15 +382,16 @@ def LoadEmulatorEfiSymbols(frame, bp_loc , internal_dict):
     Error = lldb.SBError()
     FileNamePtr = frame.FindVariable ("FileName").GetValueAsUnsigned()
     FileNameLen = frame.FindVariable ("FileNameLength").GetValueAsUnsigned()
+
     FileName = frame.thread.process.ReadCStringFromMemory (FileNamePtr, FileNameLen, Error)
     if not Error.Success():
         print "!ReadCStringFromMemory() did not find a %d byte C string at %x" % (FileNameLen, FileNamePtr)
         # make breakpoint command contiue
-        frame.GetThread().GetProcess().Continue()
+        return False
 
     debugger = frame.thread.process.target.debugger
     if frame.FindVariable ("AddSymbolFlag").GetValueAsUnsigned() == 1:
-        LoadAddress = frame.FindVariable ("LoadAddress").GetValueAsUnsigned()
+        LoadAddress = frame.FindVariable ("LoadAddress").GetValueAsUnsigned() - 0x240
 
         debugger.HandleCommand ("target modules add  %s" % FileName)
         print "target modules load --slid 0x%x %s" % (LoadAddress, FileName)
@@ -405,7 +407,7 @@ def LoadEmulatorEfiSymbols(frame, bp_loc , internal_dict):
                     print "!lldb.target.RemoveModule (%s) FAILED" % SBModule
 
     # make breakpoint command contiue
-    frame.thread.process.Continue()
+    return False
 
 def GuidToCStructStr (guid, Name=False):
   #
diff --git a/EmulatorPkg/build.sh b/EmulatorPkg/build.sh
index 60056e1b6c..35912a7775 100755
--- a/EmulatorPkg/build.sh
+++ b/EmulatorPkg/build.sh
@@ -209,21 +209,8 @@ fi
 if [[ "$RUN_EMULATOR" == "yes" ]]; then
   case `uname` in
     Darwin*)
-      #
-      # On Darwin we can't use dlopen, so we have to load the real PE/COFF images.
-      # This .gdbinit script sets a breakpoint that loads symbols for the PE/COFFEE
-      # images that get loaded in Host
-      #
-      if [[ "$CLANG_VER" == *-ccc-host-triple* ]]
-      then
-      # only older versions of Xcode support -ccc-host-tripe, for newer versions
-      # it is -target
-        cp $WORKSPACE/EmulatorPkg/Unix/lldbefi.py "$BUILD_OUTPUT_DIR/${BUILDTARGET}_$TARGET_TOOLS/$PROCESSOR"
-        cd $BUILD_ROOT_ARCH; /usr/bin/lldb --source $WORKSPACE/EmulatorPkg/Unix/lldbinit Host
-        exit $? 
-      else
-        cp $WORKSPACE/EmulatorPkg/Unix/.gdbinit "$BUILD_OUTPUT_DIR/${BUILDTARGET}_$TARGET_TOOLS/$PROCESSOR"
-      fi
+      cd $BUILD_ROOT_ARCH; /usr/bin/lldb -o "command script import $WORKSPACE/EmulatorPkg/Unix/lldbefi.py" -o 'script lldb.debugger.SetAsync(True)' -o "run" ./Host
+      exit $?
       ;;
   esac
 
-- 
2.21.0.windows.1


  parent reply	other threads:[~2019-08-16  2:14 UTC|newest]

Thread overview: 19+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-08-16  2:14 [Patch V4 00/10] EmulatorPkg: Fix VS20xx IA32 boot and simplify build config Michael D Kinney
2019-08-16  2:14 ` [Patch V4 01/10] EmulatorPkg: Fix VS20xx IA32 boot failure Michael D Kinney
2019-08-16  2:14 ` [Patch V4 02/10] EmulatorPkg: Remove UNIX_SEC_BUILD/WIN_SEC_BUILD Michael D Kinney
2019-08-16  2:14 ` [Patch V4 03/10] EmulatorPkg: Add -D DISABLE_NEW_DEPRECATED_INTERFACES Michael D Kinney
2019-08-16  2:14 ` [Patch V4 04/10] EmulatorPkg: Add support for NOOPT target Michael D Kinney
2019-08-16  2:14 ` [Patch V4 05/10] EmulatorPkg/Unix/Host: Disable inline/optimizations Michael D Kinney
2019-08-16  2:14 ` Michael D Kinney [this message]
2019-08-16  7:40   ` [Patch V4 06/10] EmulatorPkg: Fix XCODE5 lldb issues Jordan Justen
2019-08-16 15:09     ` Michael D Kinney
2019-08-16 17:30       ` [edk2-devel] " Andrew Fish
2019-08-16 18:21       ` Jordan Justen
2019-08-16 21:14         ` Michael D Kinney
2019-08-16  2:14 ` [Patch V4 07/10] EmulatorPkg/Unix/Host: Fix BerkeleyPacketFilter.c issues Michael D Kinney
2019-08-16  7:47   ` Jordan Justen
2019-08-16  2:14 ` [Patch V4 08/10] EmulatorPkg: Disable TftpDynamicCommand and LogoDxe for XCODE5 Michael D Kinney
2019-08-16  2:14 ` [Patch V4 09/10] EmulatorPkg/Sec: Change local variable scope " Michael D Kinney
2019-08-16 18:29   ` Jordan Justen
2019-08-16  2:14 ` [Patch V4 10/10] BaseTools/tools_def.template: Add -gdwarf to XCODE5 X64 Michael D Kinney
2019-08-16  4:50   ` [edk2-devel] " Liming Gao

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-list from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20190816021437.7516-7-michael.d.kinney@intel.com \
    --to=devel@edk2.groups.io \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox